/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static GC gc;
static XImage *image;
static Dimension width, height;
static Colormap colormap;
static XColor colors[7];
/* F̖Op */
static char *colornames[] = {
    "red", "orange", "yellow", "green", "light sea green", "blue", "violet"
};

/* Cxg֐ŕ`揈 (R[obN) */
static void ExposeCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (6) C[WEBhEɃRs[ */
    XPutImage(XtDisplay(w), XtWindow(w), gc, image, 0, 0, 0, 0, width, height);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg al[20];
    int ac;
    int i, j, k;
    XColor exact;
    Visual *visual;
    int depth;
    int x, y;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    /* Xc[Lbg (fBXvCI[v) */
    toplevel = XtAppInitialize(&app_context, "XMdraw", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    /* EBWFbg쐬ă}l[W */
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);
    /* Cxg֐ (R[obN) ̓o^ */
    XtAddCallback(canvas, XmNexposeCallback, ExposeCB, NULL);

    /* ftHg̃J[}bv𓾂 */
    colormap = DefaultColormapOfScreen(XtScreen(canvas));

    /* F̖OŐFt */
    for (i = 0; i < 7; i++) {
        if (XAllocNamedColor(XtDisplay(canvas), colormap,
                             colornames[i], &colors[i], &exact) == 0) {
            fprintf(stderr, "Cannot allocate color `%s'\n", colornames[i]);
            exit(1);
        }
    }

    XtRealizeWidget(toplevel); /* ŃEBhE */

    /* OtBbNEReLXg쐬ݒ */
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);

    /* (1) h[GÃEBhE𒲂ׂ */
    XtVaGetValues(canvas, XmNvisual, &visual,
                          XmNdepth,  &depth,
                          XmNwidth,  &width,
                          XmNheight, &height, NULL);
    /* (2) C[W𐶐 */
    if ((image = XCreateImage(XtDisplay(canvas), visual, depth,
                              ZPixmap, 0, NULL, width, height,
                              BitmapPad(XtDisplay(canvas)), 0)) == NULL) {
        fprintf(stderr, "Cannot create image.\n");
        exit(1);
    }
    /* (3) C[WEf[^t */
    if ((image->data = malloc(image->bytes_per_line * height)) == NULL) {
        fprintf(stderr, "Cannot allocate memory for image.\n");
        exit(1);
    }
    /* (4) C[WEf[^ */
    memset(image->data, 0, image->bytes_per_line * height);

    /* (5) 7F̑тC[WƂĕ` */
    for (i = 0; i < 7; i++) {  /* 7̐FŃ[v */
        for (j = 0; j < 140; j++) {  /* X  */
            x = j + 30;
            for (k = 0; k < 20; k++) {  /* Y  */
                y = k + i * 20 + 30;
                XPutPixel(image, x, y, colors[i].pixel);  /* Fu */
            }
        }
    }

    XtAppMainLoop(app_context);
}
