/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void SelectCB();
static void PasteCB();
static Boolean ConvertProc();
static void LoseProc();
static void DoneProc();
static void GetValueProc();

static Atom xa_targets, xa_locale, xa_ctext;
static Atom atoms[4];

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, select, paste;
    Arg al[20];
    int ac;
    XTextProperty textprop;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selection", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* eLXg͗̈ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [eLXgI] {^ --> L: ZNVL */
    ac = 0;
    select = XmCreatePushButton(panel, "select", al, ac);
    XtAddCallback(select, XmNactivateCallback, SelectCB, text);
    XtManageChild(select);

    /* [y[Xg] {^ --> v: ZNVEf[^v */
    ac = 0;
    paste = XmCreatePushButton(panel, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, text);
    XtManageChild(paste);

    /* (1) ZNṼ^[QbgpAg𐶐 */

    /* "TARGETS" ̃Ag𐶐 */
    xa_targets = XmInternAtom(XtDisplay(toplevel), "TARGETS", False);

    /* RpEhEeLXg̃Ag𐶐 */
    xa_ctext = XmInternAtom(XtDisplay(toplevel), "COMPOUND_TEXT", False);

    /* ̕R[h̃Ag𓾂 */
    if (XmbTextListToTextProperty(XtDisplay(toplevel), "", 1,
                                  XTextStyle, &textprop) != Success) {
        fprintf(stderr, "Cannot get encoding info.\n");
        exit(1);
    }
    xa_locale = textprop.encoding;

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* L: [eLXgI] {^̃R[obN */
static void SelectCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* ZNVL (3̃R[obNo^) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, DoneProc))
        /* LłCeLXg\Ēm点 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* L: ZNV̏LƂɌĂяo */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* ZNV̏L҂łȂȂC\ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* v: [y[Xg] {^̃R[obN */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* (2) L҂񋟂f[^𒲂ׂ邽߁C"TARGETS" v */
    XtGetSelectionValue(text, XA_PRIMARY, xa_targets, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* L: ZNṼf[^vꂽƂɌĂяo */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;

    if (*selection != XA_PRIMARY)  /* ̂ "PRIMARY" ZNV̂ */
        return False;

    /* vꂽ^[Qbgɉs */
    if (*target == xa_targets) {
        /* (3) "TARGETS" vꂽDL҂񋟉\ȃ^[QbgꗗԂ */
        atoms[0] = xa_targets;  /* "TARGETS" ̃Ag */
        atoms[1] = xa_locale;   /* L҂̕R[h̃Ag */
        atoms[2] = xa_ctext;    /* RpEhEeLXg̃Ag */
        atoms[3] = XA_STRING;   /* "STRING" (peLXg) ̃Ag */
        *val_ret = atoms;     /* 񋟉\ȃ^Cv̈ꗗ */
        *len_ret = 4;         /* 4̃^Cv񋟉\ */
        *type_ret = XA_ATOM;  /* ^Cṽf[^^̓Ag */
        *format_ret = 32;     /* Ag̃tH[}bg 32 rbgP */
    }
    else if (*target == xa_locale) {
        /* (5) L҂̕R[hƓOŗvꂽ */
        string = XmTextGetString(w);   /* ]͓̂͂ꂽeLXg */
        /* R[hvĂ̂ŁC̕R[ĥ܂܂œ] */
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ō NULL ǉ */
        *type_ret = xa_locale;         /* ݂̌̕R[hœ] */
        *format_ret = 8;               /* ̃tH[}bg 8 */
    }
    else if (*target == xa_ctext) {
        /* (6) RpEhEeLXgŗvꂽ */
        XTextProperty textprop;
        string = XmTextGetString(w);  /* ]͓̂͂ꂽeLXg */
        /* }`oCgRpEhEeLXgɕϊ */
        if (XmbTextListToTextProperty(XtDisplay(w), &string, 1,
                                      XStdICCTextStyle, &textprop) != Success)
            return False;  /* ϊɎs (͂ꂽ) */
        XtFree(string);
        *val_ret = textprop.value;    /* RpEhEeLXg] */
        *len_ret = strlen(textprop.value);
        *type_ret = xa_ctext;         /* {Ȃ̂ŃRpEhEeLXg */
        *format_ret = 8;              /* ̃tH[}bg 8 */
    }
    else if (*target == XA_STRING) {
        /* (7) "STRING" (peLXg) Ƃėvꂽ */
        string = XmTextGetString(w);   /* ]͓̂͂ꂽeLXg */
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ō NULL ǉ */
        *type_ret = XA_STRING;         /* ͉p̃eLXĝ݈ */
        *format_ret = 8;               /* ̃tH[}bg 8 */
    }
    else {
        return False;  /* Ȃ^Cv */
    }

    return True;   /* ]f[^̏ɐƂ} */
}

/* v: ZNṼf[^󂯎ƂɌĂяo */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* f[^̎󂯎Ɏs */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    if (*selection != XA_PRIMARY) { /* ̂ "PRIMARY" ZNV̂ */
        XBell(XtDisplay(w), 0);  /* xŎs̍} */
        return;
    }

    /* 󂯎f[^̃^CvɌ{ */
    if (*type == XA_ATOM) {
        /* (4) 󂯎f[^̃^Cv̓Ag */
        /*  "TARGETS" ̗vɑ΂Ԏ */
        int i, j;
        /* 󂯎Ag̈ꗗ́CL҂񋟉\ȃ^CṽXg */
        Atom *atomlist = val;
        atoms[0] = xa_locale;
        atoms[1] = xa_ctext;
        atoms[2] = XA_STRING;
        /* ̒Cv҂~^CvC̃^[QbgɑI */
        for (i = 0; i < 3; i++) {
            for (j = 0; j < *len; j++) {
                if (atoms[i] == atomlist[j]) {
                    /* I񂾃^[QbgŁCĂуf[^v */
                    XtGetSelectionValue(w, XA_PRIMARY, atoms[i],
                                        GetValueProc, NULL,
                                        XtLastTimestampProcessed(XtDisplay(w)));
                    XtFree((char *)val);
                    return;
                }
            }
        }
    }
    else if (*type == xa_locale) {
        /* (8) 󂯎f[^̃^Cv́C̕R[hƈv */
        /* R[hȂ̂ŁĈ܂܃eLXgɃy[Xg */
        XmTextSetString(w, (char *)val);
    }
    else if (*type == xa_ctext) {
        /* (9) 󂯎f[^̃^Cv̓RpEhEeLXg */
        XTextProperty textprop;
        char **clist;
        int count;
        /* RpEhEeLXg}`oCgɖ߂ */
        textprop.value = val;
        textprop.encoding = *type;
        textprop.format = *format;
        textprop.nitems = *len;
        if (XmbTextPropertyToTextList(XtDisplay(w),
                                      &textprop, &clist, &count) != Success)
            XBell(XtDisplay(w), 0);  /* ϊɎsƃxō} */

        /* 󂯎f[^eLXgEEBWFbgɃy[Xg */
        XmTextSetString(w, clist[0]);
        XFreeStringList(clist);  /* svȂ̂ŉ */
    }
    else if (*type == XA_STRING) {
        /* (10) 󂯎f[^̃^Cv "STRING" (peLXg) */
        XmTextSetString(w, (char *)val);
    }
    else {
        XBell(XtDisplay(w), 0);  /* ^CvႤƃxŎs̍} */
    }
    XtFree((char *)val);
}

/* L: v҂f[^󂯎ŌĂяo */
static void DoneProc(w, selection, target)
    Widget w;
    Atom *selection;
    Atom *target;
{
    /* ]ɕKvȂƂ΁CŎs */
    /* ̃R[obNo^Ƃ̓AvP[Vf[^邱 */
    /* o^Ȃꍇ́CXt IɃf[^ */
}
